-------------------------------------------------------------------------------- 
-- Copyright (c) 2004 Xilinx, Inc. 
-- All Rights Reserved 
-------------------------------------------------------------------------------- 
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /   Vendor: Xilinx 
-- \   \   \/    Author: Latha Pillai, Advanced Product Group, Xilinx, Inc.
--  \   \        Filename: FIR_SLICE
--  /   /        Date Last Modified:  June 23, 2004 
-- /___/   /\    Date Created: June 23, 2004 
-- \   \  /  \ 
--  \___\/\___\ 
-- 
--
-- Revision History: 
-------------------------------------------------------------------------------- 
--   
--   XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" 
--   AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND 
--   SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, 
--   OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, 
--   APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION 
--   THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT, 
--   AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE 
--   FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY 
--   WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE 
--   IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR 
--   REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF 
--   INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
--   FOR A PARTICULAR PURPOSE. 
--
-------------------------------------------------------------------------------- 

LIBRARY IEEE;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;

Library UNISIM;
use UNISIM.vcomponents.all;


ENTITY FIR_SLICE1 IS
   PORT (
      CLK                     : IN std_logic;   
      RST                     : IN std_logic;   
      A_IN                    : IN std_logic_vector(7 DOWNTO 0);   
      C_IN                    : IN std_logic_vector(7 DOWNTO 0);   
      PCOUT                   : OUT std_logic_vector(47 DOWNTO 0);   
      POUT                    : OUT std_logic_vector(47 DOWNTO 0));   
END FIR_SLICE1;

ARCHITECTURE FIR_SLICE OF FIR_SLICE1 IS

-- DSP48: DSP Function Block
  --        Virtex-4
  --  Xilinx HDL Language Template version 6.1i
   component DSP48
      generic( AREG : integer :=  1;
               BREG : integer :=  1;
               CREG : integer :=  1;
               PREG : integer :=  1;
               MREG : integer :=  1;
               OPMODEREG : integer :=  1;
               SUBTRACTREG : integer :=  1;
               CARRYINSELREG : integer :=  1;
               CARRYINREG : integer :=  1;
               B_INPUT : string :=  "DIRECT";
               LEGACY_MODE : string :=  "MULT18X18S" ;
			SIM_X_INPUT : string := "GENERATE_X_ONLY" );
 port(
        BCOUT                   : out std_logic_vector(17 downto 0);
        P                       : out std_logic_vector(47 downto 0);
        PCOUT                   : out std_logic_vector(47 downto 0);

        A                       : in  std_logic_vector(17 downto 0);
        B                       : in  std_logic_vector(17 downto 0);
        BCIN                    : in  std_logic_vector(17 downto 0);
        C                       : in  std_logic_vector(47 downto 0);
        CARRYIN                 : in  std_ulogic;
        CARRYINSEL              : in  std_logic_vector(1 downto 0);
        CEA                     : in  std_ulogic;
        CEB                     : in  std_ulogic;
        CEC                     : in  std_ulogic;
        CECARRYIN               : in  std_ulogic;
        CECINSUB                : in  std_ulogic;
        CECTRL                  : in  std_ulogic;
        CEM                     : in  std_ulogic;
        CEP                     : in  std_ulogic;
        CLK                     : in  std_ulogic;
        OPMODE                  : in  std_logic_vector(6 downto 0);
        PCIN                    : in  std_logic_vector(47 downto 0);
        RSTA                    : in  std_ulogic;
        RSTB                    : in  std_ulogic;
        RSTC                    : in  std_ulogic;
        RSTCARRYIN              : in  std_ulogic;
        RSTCTRL                 : in  std_ulogic;
        RSTM                    : in  std_ulogic;
        RSTP                    : in  std_ulogic;
        SUBTRACT                : in  std_ulogic
      );
  end component;

-----------------------------------------------------------------
--Signal Declarations:
signal LOW_48bit                  :  std_logic_vector(47 downto 0);
signal LOW_18bit                  :  std_logic_vector(17 downto 0);
signal LOW_10bit                   :  std_logic_vector(9 downto 0);
signal LOW_1bit                   :  std_logic;
signal HIGH_1bit                  :  std_logic;
signal CARRYINSEL_bit             :  std_logic_vector(1 downto 0);
signal OPMODE1                 :  std_logic_vector(6 downto 0);


------------------------------------------------------------------
-- Architecture Section: instantiation block 1


BEGIN

LOW_48bit        <= "000000000000000000000000000000000000000000000000";
LOW_18bit        <= "000000000000000000";
LOW_10bit        <= "0000000000";
LOW_1bit         <= '0';
HIGH_1bit        <= '1';
CARRYINSEL_bit <= "00";
OPMODE1 <= "0000101";


-- Instantiation block 1
   
    DSP48_1 : DSP48 generic map (
     AREG => 1, -- Number of pipeline registers on the A input, 0, 1 or 2
     BREG => 1, -- Number of pipeline registers on the B input, 0, 1 or 2
     B_INPUT => "DIRECT", -- B input DIRECT from fabric 
                          --or CASCADE from another DSP48
     CARRYINREG => 0, -- Number of pipeline registers 
                      -- for the CARRYIN input, 0 or 1
     CARRYINSELREG => 0, -- Number of pipeline registers 
                         -- for the CARRYINSEL, 0 or 1
     CREG => 0, -- Number of pipeline registers on the C input, 0 or 1
     LEGACY_MODE => "MULT18X18S", -- Backward compatibility, NONE, 
                                  -- MULT18X18 or MULT18X18S
     MREG => 1, -- Number of multiplier pipeline registers, 0 or 1
     OPMODEREG => 0, -- Number of pipeline registers on OPMODE input, 0 or 1
     PREG => 1, -- Number of pipeline registers on the P output, 0 or 1
     SIM_X_INPUT => "GENERATE_X_ONLY", -- Simulation parameter for 
                                       -- behavior for X on input. Possible 
                                       -- values: GENERATE_X, NONE or WARNING
     SUBTRACTREG => 0) -- Number of pipeline registers on the 
                       -- SUBTRACT input, 0 or 1
  
 port map (
     BCOUT => open,    -- 18-bit B cascade output
     P => POUT,          -- 48-bit product output
     PCOUT => PCOUT,    -- 48-bit cascade output
     A(17 downto 8) => LOW_10bit, -- 18-bit A data input
     A(7 downto 0) => C_IN,          -- 18-bit A data input
     B(17 downto 8) => LOW_10bit, -- 18-bit A data input
     B(7 downto 0) => A_IN,          -- 18-bit A data input
     BCIN => LOW_18bit,      -- 18-bit B cascade input
     C => LOW_48bit,         -- 48-bit cascade input
     CARRYIN => LOW_1bit,    -- Carry input signal
     CARRYINSEL => CARRYINSEL_bit, -- 2-bit carry input select
     CEA => HIGH_1bit,        -- A data clock enable input
     CEB => HIGH_1bit,        -- B data clock enable input
     CEC => LOW_1bit,        -- C data clock enable input
     CECARRYIN => LOW_1bit,  -- CARRYIN clock enable input
     CECINSUB => LOW_1bit,   -- CINSUB clock enable input
     CECTRL => LOW_1bit,     -- Clock Enable input for CTRL registers
     CEM => HIGH_1bit,        -- Clock Enable input for multiplier registers
     CEP => HIGH_1bit,        -- Clock Enable input for P registers
     CLK => CLK,         -- Clock input
     OPMODE => OPMODE1, -- 7-bit operation mode input
     PCIN => LOW_48bit,      -- 48-bit PCIN input     
     RSTA => RST,        -- Reset input for A pipeline registers
     RSTB => RST,        -- Reset input for B pipeline registers
     RSTC => RST,        -- Reset input for C pipeline registers
     RSTCARRYIN => RST,  -- Reset input for CARRYIN registers
     RSTCTRL => RST,     -- Reset input for CTRL registers
     RSTM => RST,        -- Reset input for multiplier registers
     RSTP => RST,        -- Reset input for P pipeline registers
     SUBTRACT => LOW_1bit    -- SUBTRACT input
  );
    -- End of DSP48_1 instantiation

   --//////////////////////////////////////////////////////////////////////////////////

END FIR_SLICE;
